import React, { useState } from 'react';
import axios from 'axios';
import Pbf from 'pbf';
import Hello from '../components/hello';
import { FeedMessage } from '../../proto2js/js/gtfs-rt.js';
import '../style.css';
const Home = () => {
    /*storage*/
    const [vehPos, setVehPos] = useState({});
    /*fetch vehPost in a JavaScript function*/
    const getVehPos = async () => {
        try {
            /*TODO handle errors: https://www.valentinog.com/blog/await-react/*/
            let url = 'https://soll.vbn.de/vehicle-positions';
            //let url = 'http://localhost:8080/vehicle-positions';
            const res = await axios.get(url,
					{
					    responseType: 'arraybuffer'
					    //responseType: 'blob'
					});
	    //TODO remove debugging
            if (res.data) {
                //console.log('getVehPos() JSON res: ', JSON.stringify(res));
                //console.log('getVehPos() res.data: ', res.data);
		const pbf = new Pbf(res.data);
                //console.log('getVehPos() JSON pbf: ', JSON.stringify(pbf));
		const feed = FeedMessage.read(pbf);
                //console.log('getVehPos() feed: ', feed);
                //console.log('getVehPos() JSON feed: ', JSON.stringify(feed));
		feed.entity.forEach(entity => {
		    const vehiclePos = entity.vehicle;
		    if (vehiclePos) {
			console.log('getVehPos() vehiclePos available');
			const { trip, position, vehicle } = vehiclePos;
			if (trip && position && vehicle) {
			    console.log('getVehPos() trip, position & vehicle available');
			} else {
			    console.error('getVehPos() trip, position & vehicle NOT unavailable ');
			}
		    } else {
			console.error('getVehPos() vehiclePos NOT available');
		    }
		});
            } else {
                console.error('getVehPos() res.data unavailable ');
            }
            /*set state*/
            setVehPos(res.data);
        } catch (err) {
            console.error('err.message: ' + err.message);
        }
    };

    return (
	<>
	    <h2>Home</h2>
	    <h3>(React.js Lambda Function Component)</h3>
	    <Hello msg="Hello World!" />
            <button onClick={getVehPos}>getVehPos</button>
	</>
    );
}

export default Home
